zoukankan      html  css  js  c++  java
  • 【19.46%】【codeforces 551B】ZgukistringZ

    time limit per test2 seconds
    memory limit per test256 megabytes
    inputstandard input
    outputstandard output
    Professor GukiZ doesn’t accept string as they are. He likes to swap some letters in string to obtain a new one.

    GukiZ has strings a, b, and c. He wants to obtain string k by swapping some letters in a, so that k should contain as many non-overlapping substrings equal either to b or c as possible. Substring of string x is a string formed by consecutive segment of characters from x. Two substrings of string x overlap if there is position i in string x occupied by both of them.

    GukiZ was disappointed because none of his students managed to solve the problem. Can you help them and find one of possible strings k?

    Input
    The first line contains string a, the second line contains string b, and the third line contains string c (1 ≤ |a|, |b|, |c| ≤ 105, where |s| denotes the length of string s).

    All three strings consist only of lowercase English letters.

    It is possible that b and c coincide.

    Output
    Find one of possible strings k, as described in the problem statement. If there are multiple possible answers, print any of them.

    Examples
    input
    aaa
    a
    b
    output
    aaa
    input
    pozdravstaklenidodiri
    niste
    dobri
    output
    nisteaadddiiklooprrvz
    input
    abbbaaccca
    ab
    aca
    output
    ababacabcc
    Note
    In the third sample, this optimal solutions has three non-overlaping substrings equal to either b or c on positions 1 – 2 (ab), 3 – 4 (ab), 5 – 7 (aca). In this sample, there exist many other optimal solutions, one of them would be acaababbcc.

    【题目链接】:http://codeforces.com/contest/551/problem/B

    【题解】

    题中说a串可以任意交换两个字符。
    其实就是说a串可以变成任意的字符;
    所以原题意等价于给你a..z的26个字母,每个字母有若干个.
    然后问你最多用这些字母组成几个b和c串.
    剩余的字母随便输出就好.
    可以这样。先全部给b用,全部给c用。
    获取b串和c串最多能组成几个.
    然后枚举b串组成了几个
    再二分c串组成了几个.
    l r
    m = (l+r)>>1;
    显然如果m情况下字母够用则可以增大m.否则减小m
    而判断i个b串j个c串是否可以用所给字母表示则可以在O(26)搞出来;
    所以复杂度就接近O(NlogN)吧。没问题的。

    【完整代码】

    #include <bits/stdc++.h>
    using namespace std;
    #define lson l,m,rt<<1
    #define rson m+1,r,rt<<1|1
    #define LL long long
    #define rep1(i,a,b) for (int i = a;i <= b;i++)
    #define rep2(i,a,b) for (int i = a;i >= b;i--)
    #define mp make_pair
    #define pb push_back
    #define fi first
    #define se second
    #define rei(x) scanf("%d",&x)
    #define rel(x) scanf("%I64d",&x)
    
    typedef pair<int,int> pii;
    typedef pair<LL,LL> pll;
    
    //const int MAXN = x;
    const int dx[9] = {0,1,-1,0,0,-1,-1,1,1};
    const int dy[9] = {0,0,0,-1,1,-1,1,-1,1};
    const double pi = acos(-1.0);
    
    string a,b,c;
    
    map <char,int> dic,dic1,dic2;
    
    int main()
    {
        //freopen("F:\rush.txt","r",stdin);
        cin >> a;
        cin >> b;
        cin >> c;
        int lena = a.size();
        rep1(i,0,lena-1)
            dic[a[i]]++;
        int lenb = b.size();
        rep1(i,0,lenb-1)
            dic1[b[i]]++;
        int lenc = c.size();
        rep1(i,0,lenc-1)
            dic2[c[i]]++;
        int num1 = 0,num2 = 0;
        int mi=21e8;
        rep1(i,1,26)
            {
                char ke = i+'a'-1;
                if (dic1[ke] > 0)
                        mi = min(mi,dic[ke]/dic1[ke]);
            }
        num1 = mi;
        mi=21e8;
        rep1(i,1,26)
            {
                char ke = i+'a'-1;
                if (dic2[ke] > 0)
                        mi = min(mi,dic[ke]/dic2[ke]);
            }
        num2 = mi;
        int ans1 = 0,ans2 = 0,ans = 0;
        rep1(i,0,num1)
            {
                int l = 0,r = num2,j=-1;
                while (l <= r)
                {
                    int m = (l+r)>>1;
                    bool ok = true;
                    rep1(k,1,26)
                    {
                        char ke = k+'a'-1;
                        int numi = i*dic1[ke]+m*dic2[ke];
                        if (numi>dic[ke])
                        {
                            ok = false;
                            break;
                        }
                    }
                    if (ok)
                    {
                        j = m,l = m+1;
                    }
                    else
                        r = m-1;
                }
                if (j!=-1 && ans < i+j)
                {
                    ans1 = i;ans2 = j;
                    ans = i+j;
                }
                if (j==-1) break;
            }
        rep1(i,1,26)
            {
                char ke = i+'a'-1;
                int numi = ans1*dic1[ke]+ans2*dic2[ke];
                dic[ke]-=numi;
            }
        string s = "";
        rep1(i,1,ans1)
            s+=b;
        rep1(i,1,ans2)
            s+=c;
        rep1(i,1,26)
        {
            char ke = i+'a'-1;
            while (dic[ke]>0)
            {
                dic[ke]--;
                s+=ke;
            }
        }
        cout << s<<endl;
        return 0;
    }
  • 相关阅读:
    centos 7 install
    sbt
    maven create project
    java异常个人理解
    (poj1094)Sorting It All Out
    stars
    Following Orders(拓扑排序)
    The House Of Santa Claus(dfs)
    Prime Path(bfs)
    Fence Repair(优先队列容器的应用)
  • 原文地址:https://www.cnblogs.com/AWCXV/p/7626825.html
Copyright © 2011-2022 走看看